#include <bits/stdc++.h>
using namespace std;
int main(){
    /*
    ios_base::sync_with_stdio(false);
    cout.tie(NULL);
    cin.tie(NULL);
    */
    long long n,m,t;
    cin >> n >> m >> t;
    vector<long long> a(n);
    for(long long i = 0;i < n;i++){
        cin >> a[i];
    }
    vector<long long> b(m);
    for(long long i = 0;i < m;i++){
        cin >> b[i];
    }
    vector<long long> ans(n,0);
    for(long long i = 0;i < n;i++){
        long long s = t - a[i];
        if(s >= 0){
            ans[i] = s / a[i] + 1;
        }
        for(long long j = i - 1;j >= 0;j--){
            s -= a[j];
            if(s >= 0){
                ans[i] = max(ans[i],s / a[j] + i - j + 1);
            }
        }
        s = t - a[i];
        for(long long j = i + 1;j < n;j++){
            s -= a[j];
            if(s >= 0){
                ans[i] = max(ans[i],s / a[j] + j - i + 1);
            }
        }
    }
    //cout << ans[4] << endl;
    long long ma = 0;
    for(long long i = 0;i < m;i++){
        ma = max(ma,ans[b[i] - 1]);
    }
    cout << ma;
}
